------------------------------------------------------------------------------
--  This file is a part of the LPP VHDL IP LIBRARY
--  Copyright (C) 2009 - 2010, Laboratory of Plasmas Physic - CNRS
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
-------------------------------------------------------------------------------
--                    Author : Alexis Jeandet
--                     Mail : alexis.jeandet@lpp.polytechnique.fr
----------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.numeric_std.ALL;
USE IEEE.std_logic_1164.ALL;

ENTITY Register_LPP_JCP IS
  GENERIC(size : INTEGER := 16);
  PORT(
    reset : IN  STD_LOGIC;
    clk   : IN  STD_LOGIC;
    D     : IN  STD_LOGIC_VECTOR(size-1 DOWNTO 0);
    Q     : OUT STD_LOGIC_VECTOR(size-1 DOWNTO 0)
    );
END ENTITY;

ARCHITECTURE ar_Register_LPP_JCP OF Register_LPP_JCP IS
BEGIN
  PROCESS(clk, reset)
  BEGIN
    IF reset = '0' THEN
      Q <= (OTHERS => '0');
    ELSIF clk'EVENT AND clk = '1' then
      Q <= D;
    END IF;
  END PROCESS;
END ar_Register_LPP_JCP;










